mDarkPact = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")

local mbartype = AceLibrary("Surface-1.0")
	local path = "Interface\\AddOns\\mDarkPact\\images\\"
	mbartype:Register("BantoBar", path.."BantoBar")
	mbartype:Register("Charcoal", path.."Charcoal")
	mbartype:Register("Glaze", path.."glaze")
	mbartype:Register("Otravi", path.."otravi")
	mbartype:Register("Perl", path.."perl")
	mbartype:Register("Smooth", path.."Smooth")
	mbartype:Register("Steel", path.."Steel")
	mbartype:Register("Striped", path.."striped")

dpmana = (GetSpellBonusDamage(6) *0.96 + 545)
mdpversion = "0.1.8"

local dewdrop = AceLibrary("Dewdrop-2.0")


function mDarkPact:ColorCoding()
	if(self.db.profile.colorcode == true) then
		local min, max = dpframe:GetMinMaxValues()
		local scalevalue = dpframe:GetValue() / (max * 0.5)
	--	self:Print(scalevalue)
		local red = 0.75 * ((scalevalue * -1) +2)
		if(red > 0.75) then
			red = 0.75
		end
		local green = 0.75 * scalevalue
		if(green < 0) then
			green = 0
		end
		if(green > 0.75) then
			green = 0.75
		end
	--      self:Print("R: "..red)
	--      self:Print("G: "..green)
	--      self:Print("B: "..blue)
	----	self:Print(" ")
		dpframe:SetStatusBarColor(red, green, 0)
	end
end

function mDarkPact:OnInitialize()
	local options = {
		type = 'group',
		args = {
			bar = {
				name = 'Bar settings',
				order = 1,
				desc = 'Settings for the bar.',
				type = 'group',
				args = {
					width = {
						type = 'range',
						name = 'Bar width',
						desc = 'Changes width of the bar',
						min = 20,
						max = 600,
						get = "GetWidth",
						set = "SetWidth",
					},
					height  = {
						type = 'range',
						name = 'Bar height',
						desc = 'Changes height of the bar',
						min = 5,
						max = 100,
						get = "GetHeight",
						set = "SetHeight",
					},
					scale  = {
						type = 'range',
						name = 'Bar scale',
						desc = 'Resizes the whole bar.',
						min = 0.1,
						max = 2,
						get = "GetScale",
						set = "SetScale",
					},
					texture = {
						name = "Bar texture", type = 'text',
						desc = "Change texture of the bar.",
						get = function() return self.db.profile.bartex end,
						set = function(v)
							self.db.profile.bartex = v
							dpframe:SetStatusBarTexture(mbartype:Fetch(v))
							backgroundwin:SetStatusBarTexture(mbartype:Fetch(v))
						end,
						validate = mbartype:List()
					},
					colorcode = {
						name = "Colorcoding", type = "toggle",
						desc = "Toggle color coding.",
						get = function() return self.db.profile.colorcode end,
						set = "ToggleColor",
					}
				}
			},
			config = {
				type = 'execute',
				desc = 'Opens configuration menu',
				name = 'Open config',
				func = "Config",
			},
			lock  = {
				name = "Lock", 
				type = 'execute',
				desc = "Toggle the lock.",
				func = "Lock",
			},
			bgalpha  = {
				type = 'range',
				name = 'Background alpha',
				desc = 'Changes transparency of the background',
				min = 0,
				max = 1,
				get = "GetAlpha",
				set = "SetAlpha",
			}
		}
	}

	self:RegisterChatCommand({"/mdarkpact", "/mdp"}, options)
	self:RegisterDB("mDarkPactDB")
	self:RegisterDefaults("profile", {
    	width = "300",
    	height = "25",
	bartex = "Ace",
	lock = "false",
	point = "CENTER",
	rel = "UIParent",
	relpoint = "CENTER",
	lockx = 0,
	locky = 0,
	bgalpha = 0.4,
	scale = 1,
	colorcode = false,
	})

	globalopts = options
	self:InitFrame()
end

function mDarkPact:OnEnable()
    -- Called when the addon is enabled
--    self:Print(self.db.profile.lockx .. self.db.profile.locky)
    self:RegisterEvent("UNIT_INVENTORY_CHANGED")
    self:RegisterEvent("UNIT_MANA")
    self:RegisterEvent("UNIT_AURA")
    self:RegisterEvent("UNIT_PET")
    if(self.db.profile.lock == "true") then
        dpframe:Hide()
    end
end

function mDarkPact:OnDisable()
    -- Called when the addon is disabled
--    self:Print("No-hoooooooo!")
      dpframe:Hide()
end


function mDarkPact:UNIT_INVENTORY_CHANGED()
	-- Updates the max value when you change stuff.
	dpmana = (GetSpellBonusDamage(6) *0.96 + 545)
    	dpframe:SetMinMaxValues(0, dpmana)
--	self:Print("New max Dark Pact value: " .. dpmana)
	dptext:SetText(UnitMana("pet") .. "/" .. math.ceil(dpmana) .. " (" .. math.ceil((UnitMana("pet")/math.ceil(dpmana)) *100) ..  "%)  ")
end

function mDarkPact:UNIT_MANA(unitID)
	if unitID ~= "pet" then return; end
	dpmana = (GetSpellBonusDamage(6) *0.96 + 545)
	if(UnitMana("pet") > dpmana) then
		dpframe:SetValue(dpmana)
      end
	if(UnitMana("pet") < dpmana) then
		dpframe:SetValue(UnitMana("pet"))
	end
	dptext:SetText(UnitMana("pet") .. "/" .. math.ceil(dpmana) .. " (" .. math.ceil((UnitMana("pet")/math.ceil(dpmana)) *100) ..  "%)  ")
	self:ColorCoding()
--	self:Print(UnitMana("pet"))
end

function mDarkPact:UNIT_PET(unitID)
	if unitID ~= "player" then return; end
	if(UnitExists("pet")) then
		dpframe:Show()
--		self:Print("Showing frame")
	else
		if(self.db.profile.lock == "true") then
			dpframe:Hide()
		end
--		self:Print("Hiding frame")
	end
end

function mDarkPact:UNIT_AURA(unitID)
	if unitID ~= "player" then return; end
	dpmana = (GetSpellBonusDamage(6) *0.96 + 545)
	dpframe:SetMinMaxValues(0, dpmana)
	if(UnitMana("pet") > dpmana) then
		dpframe:SetValue(dpmana)
      end
	if(UnitMana("pet") < dpmana) then
		dpframe:SetValue(UnitMana("pet"))
	end
--	self:Print("Updated amount of mana tapped, new value: [" .. dpmana  .. "]")
	dptext:SetText(UnitMana("pet") .. "/" .. math.ceil(dpmana) .. " (" .. math.ceil((UnitMana("pet")/math.ceil(dpmana)) *100) ..  "%)  ")
	if(self.db.profile.colorcode == true) then
		self:ColorCoding()
	end
end



function mDarkPact:InitFrame()



	local dpbar = CreateFrame("statusbar", "dpframe", UIParent)
	dpmana = (GetSpellBonusDamage(6) *0.96 + 545)

	dpbar:SetFrameStrata("LOW")
	dpbar:SetWidth(self.db.profile.width)
	dpbar:SetHeight(self.db.profile.height)
	dpbar:SetBackdrop({
		bgFile = mbartype:Fetch(self.db.profile.bartex),
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
--		insets = { left = 2, right = 2, top = 4, bottom = 4 }
	})
	dpbar:SetBackdropColor(0, 1, 0, 0)
	dpbar:SetBackdropBorderColor(0.5, 0.5, 0.5, 0)
	dpbar:ClearAllPoints()
	dpbar:SetPoint(self.db.profile.point, UIParent, self.db.profile.relpoint, self.db.profile.lockx, self.db.profile.locky)
	dpbar:SetMinMaxValues(0, dpmana)
	if(UnitMana("pet") > dpmana) then
		dpbar:SetValue(dpmana)
      end
	if(UnitMana("pet") < dpmana) then
		dpbar:SetValue(UnitMana("pet"))
	end
	dpbar:SetStatusBarTexture(mbartype:Fetch(self.db.profile.bartex))
	dpbar:SetStatusBarColor(1, 0, 1)
	dpbar:SetScale(self.db.profile.scale)
	dpframe:CreateFontString("dptext","ARTWORK","GameFontHighlight");

	dptext:SetPoint("RIGHT",dpframe,"RIGHT")
	dptext:SetText(UnitMana("pet") .. "/" .. math.ceil(dpmana) .. " (" .. math.ceil((UnitMana("pet")/math.ceil(dpmana)) *100) ..  "%)  ")



	local background = CreateFrame("statusbar", "backgroundwin", dpframe)

	background:SetFrameStrata("BACKGROUND")
	background:SetWidth(dpframe:GetWidth())
	background:SetHeight(dpframe:GetHeight())
	background:SetBackdrop({
		bgFile = mbartype:Fetch(self.db.profile.bartex),
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
--		insets = { left = 2, right = 2, top = 4, bottom = 4 }
	})
	background:SetBackdropColor(0, 1, 0, 0)
	background:SetBackdropBorderColor(0.5, 0.5, 0.5, 0)
	background:ClearAllPoints()
	background:SetPoint("CENTER")
	background:SetMinMaxValues(0, 1)
		background:SetValue(1)
	background:SetStatusBarTexture(mbartype:Fetch(self.db.profile.bartex))
	background:SetStatusBarColor(1, 0, 1)
	background:SetAlpha(0.4)

	local backgroundborder = CreateFrame("frame", "backgroundborder", dpframe)

	backgroundborder:SetFrameStrata("BACKGROUND")
	backgroundborder:SetWidth((dpframe:GetWidth() + 16))
	backgroundborder:SetHeight((dpframe:GetHeight() + 14))
	backgroundborder:SetBackdrop({
		bgFile = mbartype:Fetch("Interface\\Tooltips\\UI-Tooltip-Background"),
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileSize = 16,
		edgeSize = 16,
--		insets = { left = 2, right = 2, top = 4, bottom = 4 }
	})
	backgroundborder:SetBackdropColor(0, 0, 0, self.db.profile.bgalpha)
	backgroundborder:SetBackdropBorderColor(0.5, 0.5, 0.5, 0)
	backgroundborder:ClearAllPoints()
	backgroundborder:SetPoint("CENTER")
--	backgroundborder:SetAlpha(0.4)


	-- Title
	dpframe:CreateFontString("title","ARTWORK","GameFontHighlight");
	title:ClearAllPoints()
	title:SetPoint("CENTER", backgroundborder, "TOP")
	title:SetTextHeight("12")
	title:SetText("mDarkPact " .. mdpversion)

	-- Colors
	dpframe:SetStatusBarColor(0.22, 0.72, 0.96)
	if(self.db.profile.colorcode == true) then
		self:ColorCoding()
	end
	backgroundwin:SetStatusBarColor(0.7, 0.7, 0.7)

      dpframe:Hide()

	if(self.db.profile.lock == "false") then
		dpframe:EnableMouse(true)
		dpframe:SetMovable(true)
		dpframe:RegisterForDrag("LeftButton")
		dpframe:SetScript("OnDragStart", function(this) this:StartMoving() end)
		dpframe:SetScript("OnDragStop", function(this) this:StopMovingOrSizing() end)
		title:SetText("mDarkPact " .. mdpversion)
		self:Print("Warning - Bar unlocked. \"/mdp lock\" to lock it!")
		      dpframe:Show()
	else
		dpframe:EnableMouse(false)
		dpframe:SetMovable(false)
		title:SetText("")
	end



end

-- Slash commands
function mDarkPact:GetWidth()
    return self.db.profile.width
end

function mDarkPact:SetWidth(newValue)
    self.db.profile.width = math.floor(newValue)
    dpframe:SetWidth(newValue)
    backgroundwin:SetWidth(dpframe:GetWidth())
	backgroundborder:SetWidth(dpframe:GetWidth() + 16)
end


function mDarkPact:GetHeight()
    return self.db.profile.height
end

function mDarkPact:SetHeight(newValue)
    self.db.profile.height = math.floor(newValue)
    dpframe:SetHeight(newValue)
    backgroundwin:SetHeight(dpframe:GetHeight())
    backgroundborder:SetHeight(dpframe:GetHeight() + 14)
end

function mDarkPact:GetAlpha()
    return self.db.profile.bgalpha
end

function mDarkPact:SetAlpha(newValue)
	newValue = newValue * 100
	newValue = math.floor(newValue)
    self.db.profile.bgalpha = (newValue / 100)
    backgroundborder:SetBackdropColor(0, 0, 0, (newValue / 100))
end

function mDarkPact:GetScale()
    return self.db.profile.scale
end

function mDarkPact:SetScale(newValue)
	newValue = newValue * 100
	newValue = math.floor(newValue)
    self.db.profile.scale= (newValue / 100)

    dpframe:SetScale(newValue / 100)
end

function mDarkPact:ToggleColor(v)
	self.db.profile.colorcode = v
	if(self.db.profile.colorcode == false) then
		dpframe:SetStatusBarColor(0.22, 0.72, 0.96)
	end
	if(self.db.profile.colorcode == true) then
		self:ColorCoding()
	end
end

function mDarkPact:Lock()
	if(self.db.profile.lock == "true") then
		self.db.profile.lock = "false"
		self:Print("Bar now unlocked")
		dpframe:EnableMouse(true)
		dpframe:SetMovable(true)
		dpframe:RegisterForDrag("LeftButton")
		dpframe:SetScript("OnDragStart", function(this) this:StartMoving() end)
		dpframe:SetScript("OnDragStop", function(this) this:StopMovingOrSizing() end)
		title:SetText("mDarkPact " .. mdpversion)
	      dpframe:Show()
	else
		self.db.profile.lock = "true"
		dpframe:EnableMouse(false)
		dpframe:SetMovable(false)
		title:SetText("")
		point,relativeTo,relativePoint,xOfs,yOfs = dpframe:GetPoint()
		self.db.profile.point = point
--		self.db.profile.rel = relativeTo
		self.db.profile.relpoint = relativePoint
		self.db.profile.lockx = xOfs
		self.db.profile.locky = yOfs
		self:Print("Bar now locked at " .. math.ceil(xOfs) .. ", " .. math.ceil(yOfs))

		if(UnitExists("pet")) then
			dpframe:Show()
	--		self:Print("Showing frame")
		else
			dpframe:Hide()
	--		self:Print("Hiding frame")
		end
	end
end

function mDarkPact:Config()
dewdrop:Open(dpframe,
    'children', function()
        dewdrop:FeedAceOptionsTable(globalopts)
    end)
end


--      if(UnitMana("pet") < dpmana) then
--		dpframe:SetValue(UnitMana("pet"))
--		self:Print("New value:")
--		self:Print(UnitMana("pet"))
--      end
--      if(UnitMana("pet") > dpmana) then
--		dpframe:SetValue(dpmana)
--		self:Print("Old value:")
--		self:Print(dpmana)
--	end